﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using MindFusion.Diagramming;
using MindFusion.Diagramming.Mvc;
using System.Web.Script.Serialization;


namespace Tutorial8.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public ActionResult NodeModified(string diagramJson, string nodeJson, string nodeTag)
        {
            DiagramView view = DiagramView.FromJson(diagramJson);
            Diagram diagram = view.Diagram;
            JavaScriptSerializer jsSerializer = new JavaScriptSerializer(new ItemTypeResolver(null));
            jsSerializer.RegisterConverters(new JavaScriptConverter[] { new ShapeNodeConverter(view) });
            ShapeNode modifiedNode = jsSerializer.Deserialize<ShapeNode>(nodeJson);
			//CustomTag modifiedTag = JsonConvert.DeserializeObject<CustomTag>(nodeTag);
			//modifiedTag.XLocation = (int)modifiedNode.Bounds.X;
			//modifiedTag.YLocation = (int)modifiedNode.Bounds.Y;
			List<DiagramNode> matchingNodes = diagram.Nodes.ToList().FindAll(a => a.Id.Equals(modifiedNode.Id));
			foreach (DiagramNode node in matchingNodes)
			{
				int nodeIndex = diagram.Nodes.ToList().FindIndex(a => a.Equals(node));
				node.Text = "modified";
                diagram.Nodes.ToList().RemoveAt(nodeIndex);
				diagram.Nodes.ToList().Add(node);
			}

			view.Diagram = diagram;
			return Json(new { success = DiagramView.ToJson(view) });
        }


        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
    }
}